int lettura_tensione, lettura_corrente, lettura_media;
char x, cifra1, cifra2, cifra3, seg[10]={0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09};
long valore;


void main(void){

osccon = 0x60;

option_reg = 0x84;
intcon = 0xA0;
tmr0 = 61;

trisb = 0x80;
portb = 0x00;
trisa = 0x30;
porta = 0x00;

ansel = 0x10;
adcon0 = 1;

while(1){

lettura_media = 0;

if(porta.f5==0){
for(x=0;x<10;x++){                    //effettua dieci letture e poi ne fa la media
    lettura_tensione = adc_read(4);
    lettura_media += lettura_tensione;
    }
    lettura_media /= 10;

    valore = (long)lettura_media * 488758;           // converte tensione rilevata: 1023/5V = 0,00488758V
    valore = valore / 1000000;        // 0..1023 -> 0-50V

    cifra1 = valore / 100;            // estrae le decine di volt

    cifra2 = (valore / 10) % 10;       // estrae i volt

    cifra3 = (valore / 1) % 10;       // estrae 0.1 volt
}
else{
for(x=0;x<10;x++){
    lettura_corrente = adc_read(6);
    lettura_media += lettura_corrente;
    }
    lettura_media /= 10;

    valore = (long)lettura_media * 48518;
    valore = valore / 50000;          // 0..1023 -> 0-10A

    cifra1 = valore / 100;            // estrae gli Ampere

    cifra2 = (valore / 10) % 10;       // estrae 0.1 Ampere

    cifra3 = (valore / 1) % 10;       // estrae 0.01 Ampere
}

}
}

void interrupt(void){

if(porta.f5){
//abilita la prima cifra
 portb = seg[cifra1];
 porta = 0x83;
 delay_ms(25);
 porta = 0x87;

//abilita la seconda cifra
 portb = seg[cifra2];
 porta = 0x85;
 delay_ms(25);
 porta = 0x87;

//abilita la terza cifra
 portb = seg[cifra3];
 porta = 0x86;
 delay_ms(25);
 porta = 0x87;
}
else{
//abilita la prima cifra
 portb = seg[cifra1];
 porta = 0x0B;
 delay_ms(25);
 porta = 0x0F;

//abilita la seconda cifra
 portb = seg[cifra2];
 porta = 0x0D;
 delay_ms(25);
 porta = 0x0F;

//abilita la terza cifra
 portb = seg[cifra3];
 porta = 0x0E;
 delay_ms(25);
 porta = 0x0F;
}
intcon.tmr0if = 0;
tmr0 = 61;
}